
#include<stdio.h>
#include<stdlib.h>

#define N 16

void scambia(int *pa, int *pb) {
  int tmp = *pa;
  *pa = *pb;
  *pb = tmp;
}

void stampa_array(int *v, int n) {
  int i;
  for (i=0; i<n; i++) {
    printf("%d ", v[i] );
  }
  printf("\n");
}

void merge(int *v1, int *v2, int *v3, int n) {
  /* n e' la dimensione di v1 o v2 */
  
  int cur_pos=0;
    
  int i=0; int j=0;
  while (i<n && j<n) {
    if (v1[i] <= v2[j]) {
      v3[cur_pos]=v1[i];
      i++;
    }
    else {
      v3[cur_pos]=v2[j];
      j++;
    }
    cur_pos++;
  }

  if (i==n) {
    while (j<n) {
      v3[cur_pos]=v2[j];
      j++; cur_pos++;
    }
  }
  else {
    while (i<n) {
      v3[cur_pos]=v1[i];
      i++; cur_pos++;
    }
  }
}

void mergesort(int *v, int n) {

  if (n==1) return; /* non c'e' niente da ordinare */

  mergesort(v,n/2); /* ordina la prima meta */
  mergesort(v+n/2,n/2); /* ordina la seconda meta */

  /* fonde le due meta */

  int *v1 = calloc(n/2,sizeof(int));
  int *v2 = calloc(n/2,sizeof(int));

  int i;
  for (i=0; i<n/2; i++)
    v1[i]=v[i];
  for (i=0; i<n/2; i++)
    v2[i]=v[n/2+i];

  merge(v1,v2,v,n/2);

  free(v1);
  free(v2);
}

main() {
  
  int v[N];
  
  /* definisce v random */
  srand(time(0));
  int i;
  for (i=0; i<N; i++)
    v[i] = rand()%100;
  
  printf("Vettore Originale: ");
  stampa_array(v,N);

  /* esegue il mergesort */
  mergesort(v,N);
  
  printf("Vettore Ordinato: ");
  stampa_array(v,N);
}
