// Questo programma funziona solo se tutti gli elementi dell'array sono diversi.

#include<stdio.h>

void swap(int *a, int *b) {
  int tmp=*a;
  *a = *b;
  *b = tmp;
}

int find_pivot(int *left, int* right) {
  return *left; //*(left + (right - left)/2);
}

int *partition(int *left, int *right, int pivot) {
  while (left<=right) {
    
    while (*left<pivot)
      ++left;
  
    while (*right>=pivot)
      --right;
  
    if (left < right) {
      swap(left,right);
      ++left;
      --right;
    }
  }
  
  return left;
}


void print_array(int *a, int n) {
  
  int i;

  for (i=0; i<n; i++)
    printf("%d ", a[i]);
  
  printf("\n");
}

void quicksort(int *left, int* right) {
  int *p, pivot;

  if (left < right) {
    pivot = find_pivot(left,right);
    //printf("%s ", "ok"); 
    p=partition(left,right,pivot);
    print_array(left,right-left-1);
    quicksort(left, p-1);
    quicksort(p, right);
  } 
}

#define N 8

int main() {

  int seq[N] = { 3 , 4 , 2 , 7 , 9 , 1 , -1 , 5 };

  //printf("%d\n", seq[0]);
  
  print_array(seq,N);

  quicksort(seq, seq+N-1);

  print_array(seq,N);
}
