

#include<stdio.h>
#include<math.h>

typedef struct {

  float reale;
  float immag;

} Complesso;

Complesso Somma(Complesso c1, Complesso c2){
  Complesso new_c;
  new_c.reale = c1.reale + c2.reale;
  new_c.immag = c1.immag + c2.immag;
  return new_c;
}

Complesso Prod(Complesso c1, Complesso c2){
  Complesso new_c;
  new_c.reale = c1.reale*c2.reale - c1.immag*c2.immag;
  new_c.immag = c1.immag*c2.reale + c2.immag*c2.reale;
  return new_c;
}

void Coniuga(Complesso *c){
  c->immag = -c->immag;
}

void Leggi(Complesso *c) {
  printf("Parte reale: ");
  scanf("%f", &c->reale);
  printf("Parte immaginaria: ");
  scanf("%f", &(c->immag));
}

void Stampa(Complesso c) {
  
  if (c.immag < 0)
    printf("%f - %fi\n", c.reale, -c.immag);
  else if (c.immag == 0)
    printf("%f\n", c.reale);
  else printf("%f + %fi\n", c.reale, c.immag);

}


int main() {

  Complesso n1;
  Leggi(&n1);

  Complesso n2;
  Leggi(&n2);

  Complesso nprod, nsomma;

  nsomma = Somma(n1,n2);
  nprod = Prod(n1,n2);

  Coniuga(&n1);

  Stampa(nsomma);
  Stampa(nprod);
  Stampa(n1);
}
